src/eCommerce.BackOffice/Controllers/BanksController.cs
using eCommerce.Services.Model;
using eCommerce.Services.Notification;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace eCommerce.BackOffice.Controllers
{
    public class BanksController : Controller
    {
        private DbModelEntities modelEntities = new DbModelEntities();

        public ActionResult Index()
        {
            return View("BankList", this.BanksToList());
        }

        private List<Bank> BanksToList()
        {
            return modelEntities.Banks.Where(x => x.Deleted == null).OrderBy(x => x.Name).ToList();
        }

        [HttpGet]
        public ActionResult BankUpdate(int Id)
        {
            if (Id != -1)
            {
                var bank = modelEntities.Banks.SingleOrDefault(x => x.BankId == Id);
                return View(bank);
            }

            return View(new Bank { BankId = Id });
        }

        [HttpPost]
        public ActionResult BankUpdate(FormCollection form)
        {
            Bank bank = new Bank();

            if (form["BankId"] != string.Empty && Convert.ToInt16(form["BankId"]) > 0)
            {
                int bankId = Convert.ToInt16(form["BankId"]);
                bank = modelEntities.Banks.SingleOrDefault(x => x.BankId == bankId && x.Deleted == null);
            }

            TryUpdateModel(bank, form);

            if (bank.BankId <= 0)
            {
                bank.Created = CurrentDate.Now;
                bank.CreatedBy = User.Identity.Name;
                modelEntities.Banks.Add(bank);
            }

            modelEntities.SaveChanges();

            NotificationBar.ShowMessage(this, NotificationMessageType.Success, "Los datos fueron guardados correctamente!");
            return RedirectToAction("Index");
        }

        [HttpGet]
        public virtual PartialViewResult BankDelete(int Id)
        {
            var bank = modelEntities.Banks.SingleOrDefault(x => x.BankId == Id && x.Deleted == null);
            if (bank != null)
            {
                bank.Deleted = CurrentDate.Now;
                bank.DeletedBy = User.Identity.Name;
                modelEntities.SaveChanges();
            }

            return PartialView("_BankList", this.BanksToList());
        }        
    }
}

src/eCommerce.BackOffice/Views/Banks/BankList.cshtml
@model IEnumerable<eCommerce.Services.Model.Bank>
@{
    ViewBag.Title = "Bancos";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Listado de Bancos</h1>
    <div class="page-header-actions">
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/Banks/BankUpdate/-1'">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVO BANCO</span>
            </button>
        </div>
    </div>
</div>

<div class="page-content">

    <div class="panel">
        <div class="panel-body">
            @Html.Partial("_BankList", Model)
        </div>
    </div>

</div>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            //setActionsDialogs();
        })

        function fDelete(Id)
        {
            $.ajax({
                url: "/Banks/BankDelete/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR)
                {
                    $('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();
                    swal("Eliminado!", "", "success");
                }
            });
        }

        function fDeleteDialog(bankId)
        {
            swal({
                title: "",
                text: "Confirma su acción de Eliminar?",
                showCancelButton: true,
                confirmButtonColor: '#46be8a',
                confirmButtonText: 'Eliminar',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
         function (isConfirm) {
             if (isConfirm) {
                 fDelete(bankId);
             }
             else {
                 swal("Operación cancelada");
             }
         });

        }

        function setActionsDialogs()
        {
            $('.remove-row').on("click", function () {
                
            });
        }

    </script>

}

src/eCommerce.BackOffice/Views/Banks/BankUpdate.cshtml
@model eCommerce.Services.Model.Bank
@{
    ViewBag.Title = "Bancos";
	Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Bancos</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("BankUpdate", "Banks", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off"}))
                    {
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Nombre</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Name" value="@Model.Name" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Medio de Pago - ID<br />Decidir</label>
                            <div class="col-sm-9">
                                <input type="number" class="form-control" name="PaymenMethodId_Decidir" value="@Model.PaymenMethodId_Decidir" />
                            </div>
                        </div>
                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Banks'">Cancelar</button>
                            @Html.HiddenFor(model => model.BankId)
                        </div>
                        <input hidden="hidden" name="flagDelete" id="flagDelete" value="false" />
                    }
                </div>
            </div>
        </div>
    </div>
</div>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Name: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Nombre es requerido.'
                            }
                        }
                    },
                    Benefit: {
                        validators: {
                            numeric: {
                                message: 'Ingrese un valor correcto.',
                                separator: ','
                            }
                        }
                    }
                }
            });
        })();

        var drEvent = $('#Icon').dropify();
        drEvent.on('dropify.beforeClear', function (event, element) { $("#flagDelete").val(true); });

    </script>
}

src/eCommerce.BackOffice/Views/Banks/_BankList.cshtml
@model IEnumerable<eCommerce.Services.Model.Bank>

<table class="table table-hover dataTable table-striped width-full" data-plugin="dataTable">
    <thead>
        <tr>
            <th>Nombre</th>
            <th class="text-center">Medio de Pago - ID (Decidir)</th>
            <th class="col-xs-2 text-center">Acciones</th>
        </tr>
    </thead>
    <tbody>
    @foreach (var item in Model)
    {
        <tr>
            <td>@Html.DisplayFor(modelItem => item.Name)</td>
            <td class="text-center">@Html.DisplayFor(modelItem => item.PaymenMethodId_Decidir)</td>
            <td class="actions text-center">
                <a href="/Banks/BankUpdate/@item.BankId" class="btn btn-sm btn-icon btn-pure btn-default on-default edit-row"
                   data-toggle="tooltip" data-original-title="Editar"><i class="icon wb-edit" aria-hidden="true"></i></a>
                <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row"
                   data-toggle="tooltip" data-original-title="Eliminar" data-rowid="@item.BankId" onclick="fDeleteDialog(@item.BankId)"><i class="icon wb-trash" aria-hidden="true"></i></a>
            </td>
        </tr>
    }
    </tbody>
</table>